/***********************************************************************/
/*                                                                     */
/*  FILE        :iodefine.h                                            */
/*  DATE        :Fri, Mar 07, 2008                                     */
/*  DESCRIPTION :define the sfr register. (for C language)             */
/*  CPU GROUP   :2A                                                    */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*                                                                     */
/***********************************************************************/


#ifndef IODEFINE_H 
#define IODEFINE_H

/************************************************************************************
*																					*
*   File Name   : SFR_R82A.h														*
*   Contents    : definition of R8C/2A & R8C/2B Group SFR							*
************************************************************************************/

/********************************************************
*  declare SFR addresses                                *
********************************************************/

#define		pm0			(*(volatile union byte_def *) (0x0004))		/* Processor mode register 0 */

#define		pm1			(*(volatile union byte_def *) (0x0005))		/* Processor mode register 1 */

#define		cm0			(*(volatile union byte_def *) (0x0006))		/* System clock control register 0 */

#define		cm1			(*(volatile union byte_def *) (0x0007))		/* System clock control register 1 */

#define		mstcr		(*(volatile union byte_def *) (0x0008))		/* Module status control register */

#define		prcr		(*(volatile union byte_def *) (0x000A))		/* Protect register */

#define		ocd			(*(volatile union byte_def *) (0x000C))		/* Oscillation stop detect register */

#define		wdtr		(*(volatile union byte_def *) (0x000D))		/* Watchdog timer reset register */

#define		wdts		(*(volatile union byte_def *) (0x000E))		/* Watchdog timer start register */

#define		wdc			(*(volatile union byte_def *) (0x000F))		/* Watchdog timer control register */

#define		rmad0		(*(volatile union rmadi *) (0x0010))		/* Address match interrupt register0 */

#define		aier		(*(volatile union byte_def *) (0x0013))		/* Address match interrupt enable register */

#define		rmad1		(*(volatile union rmadi *) (0x0014))		/* Address match interrupt register1 */

#define		cspr		(*(volatile union byte_def *) (0x001C))		/* Count source protect mode register */

#define		fra0		(*(volatile union byte_def *) (0x0023))		/* High-speed on-chip oscillator contorl register 0 */

#define		fra1		(*(volatile union byte_def *) (0x0024))		/* High-speed on-chip oscillator contorl register 1 */

#define		fra2		(*(volatile union byte_def *) (0x0025))		/* High-speed on-chip oscillator contorl register 2 */

#define		cpsrf		(*(volatile union byte_def *) (0x0028))		/* Clock prescaler reset flag */

#define		fra6		(*(volatile union byte_def *) (0x002B))		/* High-speed on-chip oscillator control register 4 */

#define		fra7		(*(volatile union byte_def *) (0x002C))		/* High-speed on-chip oscillator control register 6 */

#define		vca1		(*(volatile union byte_def *) (0x0031))		/* Voltage detection register 1 */

#define		vca2		(*(volatile union byte_def *) (0x0032))		/* Voltage detection register 2 */

#define		vw1c		(*(volatile union byte_def *) (0x0036))		/* Voltage monitor 1 circuit control register */

#define		vw2c		(*(volatile union byte_def *) (0x0037))		/* Voltage monitor 2 circuit control register */

#define		vw0c		(*(volatile union byte_def *) (0x0038))		/* Voltage monitor 0 circuit control register */

#define		trcic		(*(volatile union intcr *) (0x0047))		/* Timer RC interrupt control register */

#define		trd0ic		(*(volatile union intcr *) (0x0048))		/* Timer RD0 interrupt control register */

#define		trd1ic		(*(volatile union intcr *) (0x0049))		/* Timer RD1 interrupt control register */

#define		treic		(*(volatile union intcr *) (0x004A))		/* Timer RE interrupt control register */

#define		s2tic		(*(volatile union intcr *) (0x004B))		/* UART2 transmit interrupt control register */

#define		s2ric		(*(volatile union intcr *) (0x004C))		/* UART2 receive interrupt control register */

#define		kupic		(*(volatile union intcr *) (0x004D))		/* Key input interrupt control register */

#define		ssuaic		(*(volatile union intcr *) (0x004F))		/* SSU interrupt control register */

#define		iic2aic		(*(volatile union intcr *) (0x004F))		/* IIC interrupt control register */

#define		cmp1ic		(*(volatile union intcr *) (0x0050))		/* compare 1 interrupt control register */

#define		s0tic		(*(volatile union intcr *) (0x0051))		/* UART0 transmit interrupt control register */

#define		s0ric		(*(volatile union intcr *) (0x0052))		/* UART0 receive interrupt control register */

#define		s1tic		(*(volatile union intcr *) (0x0053))		/* UART1 transmit interrupt control register */

#define		s1ric		(*(volatile union intcr *) (0x0054))		/* UART1 receive interrupt control register */

#define		int2ic		(*(volatile union intcr *) (0x0055))		/* INT2 interrupt control register */

#define		traic		(*(volatile union intcr *) (0x0056))		/* Timer RA interrupt control register */

#define		trbic		(*(volatile union intcr *) (0x0058))		/* Timer RB interrupt control register */

#define		int1ic		(*(volatile union intcr *) (0x0059))		/* INT1 interrupt control register */

#define		int3ic		(*(volatile union intcr *) (0x005A))		/* INT3 interrupt control register */

#define		trfic		(*(volatile union intcr *) (0x005B))		/* Timer RF interrupt control register */

#define		cmp0ic		(*(volatile union intcr *) (0x005C))		/* compare 0 interrupt control register */

#define		int0ic		(*(volatile union intcr *) (0x005D))		/* INT0 interrupt control register */

#define		adic		(*(volatile union intcr *) (0x005E))		/* A-D conversion interrupt control register */

#define		capic		(*(volatile union intcr *) (0x005F))		/* capture interrupt control register */

#define		u0mr		(*(volatile union uimr *) (0x00A0))			/* UART0 transmit/receive mode register */

#define		u0brg		(*(volatile union byte_def *) (0x00A1))		/* UART0 bit rate register */

#define		u0tb		(*(volatile union worddef *) (0x00A2))		/* UART0 transmit buffer register */

#define		u0c0		(*(volatile union uic0 *) (0x00A4))			/* UART0 transmit/receive control register 0 */

#define		u0c1		(*(volatile union uic1 *) (0x00A5))			/* UART0 transmit/receive control register 1 */

#define		u0rb		(*(volatile union uirb *) (0x00A6))			/* UART0 receive buffer register */

#define		u1mr		(*(volatile union uimr *) (0x00A8))			/* UART1 transmit/receive mode register */

#define		u1brg		(*(volatile union byte_def *) (0x00A9))		/* UART1 bit rate register */

#define		u1tb		(*(volatile union worddef *) (0x00AA))		/* UART1 transmit buffer register */

#define		u1c0		(*(volatile union u0c0 *) (0x00AC))			/* UART1 transmit/receive control register 0 */

#define		u1c1		(*(volatile union uic1 *) (0x00AD))			/* UART1 transmit/receive control register 1 */

#define		u1rb		(*(volatile union uirb *) (0x00AE))			/* UART1 receive buffer register */

#define		sscrh		(*(volatile union byte_def *) (0x00B8))		/* SS control register H */

#define		iccr1		(*(volatile union byte_def *) (0x00B8))		/* IIC bus control register 1 */

#define		sscrl		(*(volatile union byte_def *) (0x00B9))		/* SS control register L */

#define		iccr2		(*(volatile union byte_def *) (0x00B9))		/* IIC bus control register 2 */

#define		ssmr		(*(volatile union byte_def *) (0x00BA))		/* SS mode register */

#define		icmr		(*(volatile union byte_def *) (0x00BA))		/* IIC bus mode register */

#define		sser		(*(volatile union byte_def *) (0x00BB))		/* SS enable register */

#define		icier		(*(volatile union byte_def *) (0x00BB))		/* IIC bus interrupt enable register */

#define		sssr		(*(volatile union byte_def *) (0x00BC))		/* SS status register */

#define		icsr		(*(volatile union byte_def *) (0x00BC))		/* IIC bus status register */

#define		ssmr2		(*(volatile union byte_def *) (0x00BD))		/* SS mode register 2 */

#define		sar			(*(volatile union byte_def *) (0x00BD))		/* Slave address register */

#define		sstdr		(*(volatile union byte_def *) (0x00BE))		/* SS transmit data register */

#define		icdrt		(*(volatile union byte_def *) (0x00BE))		/* IIC bus transmit data register */

#define		ssrdr		(*(volatile union byte_def *) (0x00BF))		/* SS receive data register */

#define		icdrr		(*(volatile union byte_def *) (0x00BF))		/* IIC bus receive data register */

#define		da0			(*(volatile union byte_def *) (0x00D8))		/* D-A register 0 */

#define		da1			(*(volatile union byte_def *) (0x00DA))		/* D-A register 1 */

#define		dacon0		(*(volatile union byte_def *) (0x00DC))		/* D-A control register */

#define		p0			(*(volatile union byte_def *) (0x00E0))		/* Port P0 register */

#define		p1			(*(volatile union byte_def *) (0x00E1))		/* Port P1 register */

#define		pd0			(*(volatile union byte_def *) (0x00E2))		/* Port P0 direction register */

#define		pd1			(*(volatile union byte_def *) (0x00E3))		/* Port P1 direction register */

#define		p2			(*(volatile union byte_def *) (0x00E4))		/* Port P2 register */

#define		p3			(*(volatile union byte_def *) (0x00E5))		/* Port P3 register */

#define		pd2			(*(volatile union byte_def *) (0x00E6))		/* Port P2 direction register */

#define		pd3			(*(volatile union byte_def *) (0x00E7))		/* Port P3 direction register */

#define		p4			(*(volatile union byte_def *) (0x00E8))		/* Port P4 register */

#define		p5			(*(volatile union byte_def *) (0x00E9))		/* Port P5 register */

#define		pd4			(*(volatile union byte_def *) (0x00EA))		/* Port P4 direction register */

#define		pd5			(*(volatile union byte_def *) (0x00EB))		/* Port P5 direction register */

#define		p6			(*(volatile union byte_def *) (0x00EC))		/* Port P6 register */

#define		pd6			(*(volatile union byte_def *) (0x00EE))		/* Port P6 direction register */

#define		p2drr		(*(volatile union byte_def *) (0x00F4))		/* Port P2 drive capacity control register */

#define		u1sr		(*(volatile union byte_def *) (0x00F5))		/* UART1 function select register */

#define		pmr			(*(volatile union byte_def *) (0x00F8))		/* Port mode register */

#define		inten		(*(volatile union byte_def *) (0x00F9))		/* External interrupt enable register */

#define		intf		(*(volatile union byte_def *) (0x00FA))		/* External interrupt filter select register */

#define		kien		(*(volatile union byte_def *) (0x00FB))		/* Key input enable register */

#define		pur0		(*(volatile union byte_def *) (0x00FC))		/* Pull-up control register0 */

#define		pur1		(*(volatile union byte_def *) (0x00FD))		/* Pull-up control register1 */

#define		tracr		(*(volatile union byte_def *) (0x0100))		/* Timer RA control register */

#define		traioc		(*(volatile union byte_def *) (0x0101))		/* Timer RA I/O control register */

#define		tramr		(*(volatile union byte_def *) (0x0102))		/* Timer RA mode register */

#define		trapre		(*(volatile union byte_def *) (0x0103))		/* Timer RA prescaler register */

#define		tra			(*(volatile union byte_def *) (0x0104))		/* Timer RA register */

#define		lincr		(*(volatile union byte_def *) (0x0106))		/* LIN control register */

#define		linst		(*(volatile union byte_def *) (0x0107))		/* LIN status register */

#define		trbcr		(*(volatile union byte_def *) (0x0108))		/* Timer RB control register */

#define		trbocr		(*(volatile union byte_def *) (0x0109))		/* Timer RB one-shot control register */

#define		trbioc		(*(volatile union byte_def *) (0x010A))		/* Timer RB I/O control register */

#define		trbmr		(*(volatile union byte_def *) (0x010B))		/* Timer RB mode register */

#define		trbpre		(*(volatile union byte_def *) (0x010C))		/* Timer RB prescaler register */

#define		trbsc		(*(volatile union byte_def *) (0x010D))		/* Timer RB secondary register */

#define		trbpr		(*(volatile union byte_def *) (0x010E))		/* Timer RB primary register */

#define		tresec		(*(volatile union byte_def *) (0x0118))		/* Timer RE seconds data register / Timer RE counter data register */

#define		tremin		(*(volatile union byte_def *) (0x0119))		/* Timer RE minutes data register / Timer RE compare data register */

#define		trehr		(*(volatile union byte_def *) (0x011A))		/* Timer RE hours data register */

#define		trewk		(*(volatile union byte_def *) (0x011B))		/* Timer RE days of week data register */

#define		trecr1		(*(volatile union byte_def *) (0x011C))		/* Timer RE control register1 */

#define		trecr2		(*(volatile union byte_def *) (0x011D))		/* Timer RE control register2 */

#define		trecsr		(*(volatile union byte_def *) (0x011E))		/* Timer RE count source select register */

#define		trcmr		(*(volatile union byte_def *) (0x0120))		/* Timer RC mode register */

#define		trccr1		(*(volatile union byte_def *) (0x0121))		/* Timer RC control register 1 */

#define		trcier		(*(volatile union byte_def *) (0x0122))		/* Timer RC interrupt enable register */

#define		trcsr		(*(volatile union byte_def *) (0x0123))		/* Timer RC status register */

#define		trcior0		(*(volatile union byte_def *) (0x0124))		/* Timer RC I/O control register 0 */

#define		trcior1		(*(volatile union byte_def *) (0x0125))		/* Timer RC I/O control register 1 */

#define		trc			(*(volatile unsigned short *) (0x0126))		/* Timer RC register */

#define		trcgra		(*(volatile unsigned short *) (0x0128))		/* Timer RC general register A0 */

#define		trcgrb		(*(volatile unsigned short *) (0x012A))		/* Timer RC general register B0 */

#define		trcgrc		(*(volatile unsigned short *) (0x012C))		/* Timer RC general register C0 */

#define		trcgrd		(*(volatile unsigned short *) (0x012E))		/* Timer RC general register D0 */

#define		trccr2		(*(volatile union byte_def *) (0x0130))		/* Timer RC control register 2 */

#define		trcdf		(*(volatile union byte_def *) (0x0131))		/* Timer RC digital filter function selection register */

#define		trcoer		(*(volatile union byte_def *) (0x0132))		/* Timer RC output master enable register */

#define		trdstr		(*(volatile union byte_def *) (0x0137))		/* Timer RD start register */

#define		trdmr		(*(volatile union byte_def *) (0x0138))		/* Timer RD mode register */

#define		trdpmr		(*(volatile union byte_def *) (0x0139))		/* Timer RD PWM mode register */

#define		trdfcr		(*(volatile union byte_def *) (0x013A))		/* Timer RD function control register */

#define		trdoer1		(*(volatile union byte_def *) (0x013B))		/* Timer RD output master enable register 1 */

#define		trdoer2		(*(volatile union byte_def *) (0x013C))		/* Timer RD output master enable register 2 */

#define		trdocr		(*(volatile union byte_def *) (0x013D))		/* Timer RD output control register */

#define		trddf0		(*(volatile union byte_def *) (0x013E))		/* Timer RD digital filter function selection register 0 */

#define		trddf1		(*(volatile union byte_def *) (0x013F))		/* Timer RD digital filter function selection register 1 */

#define		trdcr0		(*(volatile union byte_def *) (0x0140))		/* Timer RD control register 0 */

#define		trdiora0	(*(volatile union byte_def *) (0x0141))		/* Timer RD I/O contorol register A0 */

#define		trdiorc0	(*(volatile union byte_def *) (0x0142))		/* Timer RD I/O contorol register C0 */

#define		trdsr0		(*(volatile union byte_def *) (0x0143))		/* Timer RD status register 0 */

#define		trdier0		(*(volatile union byte_def *) (0x0144))		/* Timer RD interrupt enable register 0 */

#define		trdpocr0	(*(volatile union byte_def *) (0x0145))		/* Timer RD PWM mode output level control register 0 */

#define		trd0		(*(volatile unsigned short *) (0x0146))		/* Timer RD counter 0 */

#define		trdgra0		(*(volatile unsigned short *) (0x0148))		/* Timer RD general register A0 */

#define		trdgrb0		(*(volatile unsigned short *) (0x014A))		/* Timer RD general register B0 */

#define		trdgrc0		(*(volatile unsigned short *) (0x014C))		/* Timer RD general register C0 */

#define		trdgrd0		(*(volatile unsigned short *) (0x014E))		/* Timer RD general register D0 */

#define		trdcr1		(*(volatile union byte_def *) (0x0150))		/* Timer RD control register 1 */

#define		trdiora1	(*(volatile union byte_def *) (0x0151))		/* Timer RD I/O contorol register A1 */

#define		trdiorc1	(*(volatile union byte_def *) (0x0152))		/* Timer RD I/O contorol register C1 */

#define		trdsr1		(*(volatile union byte_def *) (0x0153))		/* Timer RD status register 1 */

#define		trdier1		(*(volatile union byte_def *) (0x0154))		/* Timer RD interrupt enable register 1 */

#define		trdpocr1	(*(volatile union byte_def *) (0x0155))		/* Timer RD PWM mode output level control register 1 */

#define		trd1		(*(volatile unsigned short *) (0x0156))		/* Timer RD counter 1 */

#define		trdgra1		(*(volatile unsigned short *) (0x0158))		/* Timer RD general register A1 */

#define		trdgrb1		(*(volatile unsigned short *) (0x015A))		/* Timer RD general register B1 */

#define		trdgrc1		(*(volatile unsigned short *) (0x015C))		/* Timer RD general register C1 */

#define		trdgrd1		(*(volatile unsigned short *) (0x015E))		/* Timer RD general register D1 */

#define		u2mr		(*(volatile union uimr *) (0x0160))			/* UART2 transmit/receive mode register */

#define		u2brg		(*(volatile union byte_def *) (0x0161))		/* UART2 bit rate register */

#define		u2tb		(*(volatile union worddef *) (0x0162))		/* UART2 transmit buffer register */

#define		u2c0		(*(volatile union uic0 *) (0x0164))			/* UART2 transmit/receive control register 0 */

#define		u2c1		(*(volatile union uic1 *) (0x0165))			/* UART2 transmit/receive control register 1 */

#define		u2rb		(*(volatile union uirb *) (0x0166))			/* UART2 receive buffer register */

#define		fmr4		(*(volatile union byte_def *) (0x01B3))		/* Flash memory control register 4 */

#define		fmr1		(*(volatile union byte_def *) (0x01B5))		/* Flash memory control register 1 */

#define		fmr0		(*(volatile union byte_def *) (0x01B7))		/* Flash memory control register 0 */

#define		trf			(*(volatile unsigned short *) (0x0290))		/* Timer RF register */

#define		trfcr0		(*(volatile union byte_def *) (0x029A))		/* Timer RF control register 0 */

#define		trfcr1		(*(volatile union byte_def *) (0x029B))		/* Timer RF control register 0 */

#define		trfm0		(*(volatile unsigned short *) (0x029C))		/* Timer RF capture compare register 0 */

#define		trfm1		(*(volatile unsigned short *) (0x029E))		/* Timer RF compare register 1 */

#define		ad0			(*(volatile union worddef *) (0x02C0))		/* A-D register */

#define		adcon2		(*(volatile union byte_def *) (0x02D4))		/* A-D control register 2 */

#define		adcon0		(*(volatile union byte_def *) (0x02D6))		/* A-D control register 0 */

#define		adcon1		(*(volatile union byte_def *) (0x02D7))		/* A-D control register 1 */

#define		pd8			(*(volatile union byte_def *) (0x02E4))		/* Port P8 direction register */

#define		p8			(*(volatile union byte_def *) (0x02E6))		/* Port P8 register */

#define		pur2		(*(volatile union byte_def *) (0x02FC))		/* Pull-up control register1 */

#define		trfout		(*(volatile union byte_def *) (0x02FF))		/* Timer RF output register */

/********************************************************
*  declare SFR bit                                      *
********************************************************/
struct	bit_def {
	char	b0:1;
	char	b1:1;
	char	b2:1;
	char	b3:1;
	char	b4:1;
	char	b5:1;
	char	b6:1;
	char	b7:1;
};
union	byte_def{
	struct	bit_def bit;
	char	byte;
};

/*------------------------------------------------------
  Processor mode register0
------------------------------------------------------*/



#define		pm03		pm0.bit.b3			/* Software reset bit */

/*------------------------------------------------------
  Processor mode register1
------------------------------------------------------*/



#define		pm12		pm1.bit.b2			/* WDT interrupt/reset switch bit */

/*------------------------------------------------------
  System clock control register0
------------------------------------------------------*/



#define		cm02		cm0.bit.b2			/* WAIT peripheral function clock stop bit */
#define		cm04		cm0.bit.b4			/* Port XC Switch bit */
#define		cm05		cm0.bit.b5			/* Xin clock (Xin-Xout) stop bit */
#define		cm06		cm0.bit.b6			/* System clock division select bit0 */
#define		cm07		cm0.bit.b7			/* CPU Clock Select bit */

/*------------------------------------------------------
  System clock control register1
------------------------------------------------------*/



#define		cm10		cm1.bit.b0			/* All clock stop control bit */
#define		cm11		cm1.bit.b1
#define		cm12		cm1.bit.b2			/* XCIN-XCOUT internal resistor select bit */
#define		cm13		cm1.bit.b3			/* Port Xin-Xout switch bit */
#define		cm14		cm1.bit.b4			/* Low-speed on-chip oscillation stop bit */
#define		cm15		cm1.bit.b5			/* Xin-Xout drive capacity select bit */
#define		cm16		cm1.bit.b6			/* System clock division select bit1 */
#define		cm17		cm1.bit.b7			/* System clock division select bit1 */

/*------------------------------------------------------
  Module status control register
------------------------------------------------------*/

#define		mst_iic		mstcr.bit.b3
#define		mst_trd		mstcr.bit.b4
#define		mst_trc		mstcr.bit.b5

/*------------------------------------------------------
  Address match interrupt enable register
------------------------------------------------------*/



#define		aier0		aier.bit.b0		/* Address match interrupt 0 enable bit */
#define		aier1		aier.bit.b1		/* Address match interrupt 1 enable bit */

/*------------------------------------------------------
  Protect register
------------------------------------------------------*/



#define		prc0		prcr.bit.b0		/* Protect bit0 */
#define		prc1		prcr.bit.b1		/* Protect bit1 */
#define		prc2		prcr.bit.b2		/* Protect bit2 */
#define		prc3		prcr.bit.b3		/* Protect bit3 */

/*------------------------------------------------------
  Oscillation stop detection register
------------------------------------------------------*/



#define		ocd0		ocd.bit.b0			/* Oscillation stop detection enable bit */
#define		ocd1		ocd.bit.b1			/* Oscillation stop detection interrupt enable bit */
#define		ocd2		ocd.bit.b2			/* System clock select bit */
#define		ocd3		ocd.bit.b3			/* Clock monitor bit */

/*------------------------------------------------------
  Watchdog timer reset register
------------------------------------------------------*/



/*------------------------------------------------------
  Watchdog timer start register
------------------------------------------------------*/



/*------------------------------------------------------
  Watchdog timer control register
------------------------------------------------------*/



#define		wdc7		wdc.bit.b7			/* Prescaler select bit */

/*------------------------------------------------------
  Count source protection mode register
------------------------------------------------------*/


#define		cspro		cspr.bit.b7		/* Count source protection mode select bit */

/*------------------------------------------------------
  High-speed on-chip oscillator control register 0
------------------------------------------------------*/



#define		fra00		fra0.bit.b0		/* High-speed on-chip oscillator enable bit */
#define		fra01		fra0.bit.b1		/* High-speed on-chip oscillator select bit */

/*------------------------------------------------------
  High-speed on-chip oscillator control register 1
------------------------------------------------------*/



/*------------------------------------------------------
  High-speed on-chip oscillator control register 2
------------------------------------------------------*/



#define		fra20		fra2.bit.b0		/* High-speed on-chip oscillator frequency switching bit */
#define		fra21		fra2.bit.b1		/* High-speed on-chip oscillator frequency switching bit */
#define		fra22		fra2.bit.b2		/* High-speed on-chip oscillator frequency switching bit */

/*------------------------------------------------------
  Clock prescaler reset flag
------------------------------------------------------*/



#define		cpsr		cpsrf.bit.b7		/* Clock prescaler reset flag */

/*------------------------------------------------------
  Voltage detection register 1
------------------------------------------------------*/



#define		vca13		vca1.bit.b3		/* Voltage detection 2 signal monitor flag */

/*------------------------------------------------------
  Voltage detection register 2
------------------------------------------------------*/



#define		vca25		vca2.bit.b5		/* Voltage detection 0 enable bit */
#define		vca26		vca2.bit.b6		/* Voltage detection 1 enable bit */
#define		vca27		vca2.bit.b7		/* Voltage detection 2 enable bit */

/*------------------------------------------------------
  Voltage monitor 1 circuit control register
------------------------------------------------------*/



#define		vw1c0		vw1c.bit.b0		/* Voltage monitor 1 interrupt / reset enable bit */
#define		vw1c1		vw1c.bit.b1		/* Voltage Monitor 1 digital filter disable mode select bit */
#define		vw1c2		vw1c.bit.b2		/* Voltage change detection flag */
#define		vw1c3		vw1c.bit.b3		/* Voltage detection 1 signal monitor flag */
#define		vw1f0		vw1c.bit.b4		/* Sampling clock select bit */
#define		vw1f1		vw1c.bit.b5		/* Sampling clock select bit */
#define		vw1c6		vw1c.bit.b6		/* Voltage monitor 1 circuit mode select bit */
#define		vw1c7		vw1c.bit.b7		/* Voltage monitor 1 interrupt / reset generation condition select bit */

/*------------------------------------------------------
  Voltage monitor 2 circuit control register
------------------------------------------------------*/



#define		vw2c0		vw2c.bit.b0		/* Voltage monitor 2 interrupt / reset enable bit */
#define		vw2c1		vw2c.bit.b1		/* Voltage monitor 2 digital filter disabled mode select bit */
#define		vw2c2		vw2c.bit.b2		/* Voltage change detection flag */
#define		vw2c3		vw2c.bit.b3		/* WDT Detection Flag */
#define		vw2f0		vw2c.bit.b4		/* Sampling clock select bit */
#define		vw2f1		vw2c.bit.b5		/* Sampling clock select bit */
#define		vw2c6		vw2c.bit.b6		/* Voltage monitor 2 circuit mode select bit */
#define		vw2c7		vw2c.bit.b7		/* Voltage monitor 2 interrupt / reset generation condition select bit */

/*------------------------------------------------------
  Voltage monitor 0 circuit control register
------------------------------------------------------*/



#define		vw0c0		vw0c.bit.b0		/* Voltage monitor 0 reset enable bit */
#define		vw0c1		vw0c.bit.b1		/* Voltage monitor 0 digital filter disabled mode select bit */
#define		vw0c2		vw0c.bit.b2		/*  */
#define		vw0f0		vw0c.bit.b4		/* Sampling clock select bit */
#define		vw0f1		vw0c.bit.b5		/* Sampling clock select bit */
#define		vw0c6		vw0c.bit.b6		/* Voltage monitor 0 circuit mode select bit */
#define		vw0c7		vw0c.bit.b7		/* Voltage monitor 0 reset generation condition select bit */

/*------------------------------------------------------
  UART0 bit rate register
------------------------------------------------------*/



/*------------------------------------------------------
  UART1 bit rate register
------------------------------------------------------*/



/*------------------------------------------------------
  SS control register H
------------------------------------------------------*/



#define		cks0_sscrh	sscrh.bit.b0		/* Transfer clock rate select bit */
#define		cks1_sscrh	sscrh.bit.b1		/* Transfer clock rate select bit */
#define		cks2_sscrh	sscrh.bit.b2		/* Transfer clock rate select bit */
#define		mss_sscrh	sscrh.bit.b5		/* Master/Slave device select bit */
#define		rsstp_sscrh	sscrh.bit.b6		/* Receive single stop bit */

/*------------------------------------------------------
  SS control register L
------------------------------------------------------*/



#define		sres_sscrl	sscrl.bit.b1		/* Clock synchronous serial I/O with chip select control part reset bit */
#define		solp_sscrl	sscrl.bit.b4		/* SOL write protect bit */
#define		sol_sscrl	sscrl.bit.b5		/* Serial data output value setting bit */

/*------------------------------------------------------
  SS mode register
------------------------------------------------------*/



#define		bc0_ssmr	ssmr.bit.b0		/* Bit counter 2 to 0*/
#define		bc1_ssmr	ssmr.bit.b1		/* Bit counter 2 to 0*/
#define		bc2_ssmr	ssmr.bit.b2		/* Bit counter 2 to 0*/
#define		cphs_ssmr	ssmr.bit.b5		/* SSCK clock phase select bit */
#define		cpos_ssmr	ssmr.bit.b6		/* SSCK clock polarity select bit */
#define		mls_ssmr	ssmr.bit.b7		/* MSB first/ LSB first select bit */

/*------------------------------------------------------
  SS enable register
------------------------------------------------------*/



#define		ceie_sser	sser.bit.b0		/* Conflict error interrupt enable bit */
#define		re_sser		sser.bit.b3		/* Receive enable bit */
#define		te_sser		sser.bit.b4		/* Transmit enable bit */
#define		rie_sser	sser.bit.b5		/* Receive interrupt enable bit */
#define		teie_sser	sser.bit.b6		/* Transmit end interrupt enable bit */
#define		tie_sser	sser.bit.b7		/* Transmit interrupt enable bit */

/*------------------------------------------------------
  SS status register
------------------------------------------------------*/



#define		ce_sssr		sssr.bit.b0		/* Conflict error flag */
#define		orer_sssr	sssr.bit.b2		/* Overrun error flag */
#define		rdrf_sssr	sssr.bit.b5		/* Receive data register full */
#define		tend_sssr	sssr.bit.b6		/* Transmit end */
#define		tdre_sssr	sssr.bit.b7		/* Transmit data empty */

/*------------------------------------------------------
  SS mode register 2
------------------------------------------------------*/



#define		ssums_ssmr2	ssmr2.bit.b			/* Clock synchronous serial I/O with chip select mode select bit */
#define		csos_ssmr2	ssmr2.bit.b1		/* SCS pin open drain output select bit */
#define		soos_ssmr2	ssmr2.bit.b2		/* SSO pin open drain output select bit */
#define		sckos_ssmr2	ssmr2.bit.b3		/* SSCK pin open drain output select bit */
#define		css0_ssmr2	ssmr2.bit.b4		/* SCS pin selsct bit */
#define		css1_ssmr2	ssmr2.bit.b5		/* SCS pin select bit */
#define		scks_ssmr2	ssmr2.bit.b6		/* SSCK pin select bit */
#define		bide_ssmr2	ssmr2.bit.b7		/* Bidirectional mode enable bit */

/*------------------------------------------------------
  SS transmit data register
------------------------------------------------------*/



/*------------------------------------------------------
  SS receive data register
------------------------------------------------------*/



/*------------------------------------------------------
  IIC bus control register 1
------------------------------------------------------*/



#define		cks0_iccr1	iccr1.bit.b0		/* Transmit clock select bit 3 to 0 */
#define		cks1_iccr1	iccr1.bit.b1		/* Transmit clock select bit 3 to 0 */
#define		cks2_iccr1	iccr1.bit.b2		/* Transmit clock select bit 3 to 0 */
#define		cks3_iccr1	iccr1.bit.b3		/* Transmit clock select bit 3 to 0 */
#define		trs_iccr1	iccr1.bit.b4		/* Transfer/receive select bit */
#define		mst_iccr1	iccr1.bit.b5		/* Master/slave select bit */
#define		rcvd_iccr1	iccr1.bit.b6		/* Receive disable bit */
#define		ice_iccr1	iccr1.bit.b7		/* IIC bus interface enable bit */

/*------------------------------------------------------
  IIC bus control register 2
------------------------------------------------------*/



#define		iicrst_iccr2	iccr2.bit.b1	/* IIC control part reset bit */
#define		sclo_iccr2		iccr2.bit.b3	/* SCL monitor flag */
#define		sdaop_iccr2		iccr2.bit.b4	/* SDAO write protect bit */
#define		sdao_iccr2		iccr2.bit.b5	/* SDA output value control bit */
#define		scp_iccr2		iccr2.bit.b6	/* Start/Stop condition generation disable bit */
#define		bbsy_iccr2		iccr2.bit.b7	/* Bus busy bit */

/*------------------------------------------------------
  IIC bus mode register
------------------------------------------------------*/



#define		bc0_icmr	icmr.bit.b0		/* Bit counter 2 to 0 */
#define		bc1_icmr	icmr.bit.b1		/* Bit Counter 2 to 0 */
#define		bc2_icmr	icmr.bit.b2		/* Bit Counter 2 to 0 */
#define		bcwp_icmr	icmr.bit.b3		/* BC write protect bit */
#define		wait_icmr	icmr.bit.b6		/* Wait insertion bit */
#define		mls_icmr	icmr.bit.b7		/* MSB-First/LSB-First select */

/*------------------------------------------------------
  IIC bus interrupt enable register
------------------------------------------------------*/



#define		ackbt_icier	icier.bit.b0		/* Transmit acknow ledge select bit */
#define		ackbr_icier	icier.bit.b1		/* Receive acknow ledge bit */
#define		acke_icier	icier.bit.b2		/* Acknowledge bit judgement select bit */
#define		stie_icier	icier.bit.b3		/* Stop condition detection interrupt enable bit */
#define		nakie_icier	icier.bit.b4		/* NACK receive interrupt enable bit */
#define		rie_icier	icier.bit.b5		/* Receive interrupt enable bit */
#define		teie_icier	icier.bit.b6		/* Transmit end interrupt enable bit */
#define		tie_icier	icier.bit.b7		/* Transmit interrupt enable bit */

/*------------------------------------------------------
  IIC bus status register
------------------------------------------------------*/



#define		adz_icsr	icsr.bit.b0		/* General call address recognition flag */
#define		aas_icsr	icsr.bit.b1		/* Slave address recognition flag */
#define		al_icsr		icsr.bit.b2		/* Arbitration lost flag / Overrun error flag */
#define		stop_icsr	icsr.bit.b3		/* Stop condition detection flag */
#define		nackf_icsr	icsr.bit.b4		/* No acknow ledge detection flag */
#define		rdrf_icsr	icsr.bit.b5		/* Receive data register full */
#define		tend_icsr	icsr.bit.b6		/* Transmit end */
#define		tdre_icsr	icsr.bit.b7		/* Transmit data empty */

/*------------------------------------------------------
  Slave address register
------------------------------------------------------*/



#define		fs_sar		sar.bit.b0			/* Format select bit */
#define		sva0_sar	sar.bit.b1			/* Slave address 6 to 0 */
#define		sva1_sar	sar.bit.b2			/* Slave address 6 to 0 */
#define		sva2_sar	sar.bit.b3			/* Slave address 6 to 0 */
#define		sva3_sar	sar.bit.b4			/* Slave address 6 to 0 */
#define		sva4_sar	sar.bit.b5			/* Slave address 6 to 0 */
#define		sva5_sar	sar.bit.b6			/* Slave address 6 to 0 */
#define		sva6_sar	sar.bit.b7			/* Slave address 6 to 0 */

/*------------------------------------------------------
  IIC bus transmit data register
------------------------------------------------------*/



/*------------------------------------------------------
  IIC bus receive data register
------------------------------------------------------*/



/*------------------------------------------------------
  A-D control register2
------------------------------------------------------*/



#define		smp			adcon2.bit.b0		/* A-D conversion method select bit */
#define		adgsel0		adcon2.bit.b3		/* A-D input group select bit */

#define		ADSMP		0
#define		ADGSEL0		3

/*------------------------------------------------------
  A-D control register0
------------------------------------------------------*/



#define		ch0			adcon0.bit.b0		/* Analog input pin select bit */
#define		ch1			adcon0.bit.b1		/* Analog input pin select bit */
#define		ch2			adcon0.bit.b2		/* Analog input pin select bit */
#define		md0			adcon0.bit.b3		/* A-D operation mode select bit0 */
#define		md1			adcon0.bit.b4		/* A-D operation mode select bit1 */
#define		adcap		adcon0.bit.b5		/* A-D conversion automatic start bit */
#define		adst		adcon0.bit.b6		/* A-D conversion start flag */
#define		cks0		adcon0.bit.b7		/* Frequency select bit0 */
#define		cks0_adcon0	cks0

#define		ADCH0		0
#define		ADCH1		1
#define		ADCH2		2
#define		ADMD0		3
#define		ADMD1		4
#define		ADCAP		5
#define		ADST		6
#define		ADCKS0		7

/*------------------------------------------------------
  A-D control register1
------------------------------------------------------*/


#define		bits		adcon1.bit.b3		/* 8/10-bit mode select bit */
#define		cks1		adcon1.bit.b4		/* Frequency select bit1 */
#define		cks1_adcon1	cks1
#define		vcut		adcon1.bit.b5		/* Vref connect bit */

#define		ADBITS		3
#define		ADCKS1		4
#define		ADVCUT		5

/*------------------------------------------------------
  Port P0 register
------------------------------------------------------*/



#define		p0_0		p0.bit.b0			/* Port P00 bit */
#define		p0_1		p0.bit.b1			/* Port P01 bit */
#define		p0_2		p0.bit.b2			/* Port P02 bit */
#define		p0_3		p0.bit.b3			/* Port P03 bit */
#define		p0_4		p0.bit.b4			/* Port P04 bit */
#define		p0_5		p0.bit.b5			/* Port P05 bit */
#define		p0_6		p0.bit.b6			/* Port P06 bit */
#define		p0_7		p0.bit.b7			/* Port P07 bit */

/*------------------------------------------------------
  Port P0 direction register
------------------------------------------------------*/



#define		pd0_0		pd0.bit.b0			/* Port P00 direction bit */
#define		pd0_1		pd0.bit.b1			/* Port P01 direction bit */
#define		pd0_2		pd0.bit.b2			/* Port P02 direction bit */
#define		pd0_3		pd0.bit.b3			/* Port P03 direction bit */
#define		pd0_4		pd0.bit.b4			/* Port P04 direction bit */
#define		pd0_5		pd0.bit.b5			/* Port P05 direction bit */
#define		pd0_6		pd0.bit.b6			/* Port P06 direction bit */
#define		pd0_7		pd0.bit.b7			/* Port P07 direction bit */

/*------------------------------------------------------
  Port P1 register
------------------------------------------------------*/



#define		p1_0		p1.bit.b0			/* Port P10 bit */
#define		p1_1		p1.bit.b1			/* Port P11 bit */
#define		p1_2		p1.bit.b2			/* Port P12 bit */
#define		p1_3		p1.bit.b3			/* Port P13 bit */
#define		p1_4		p1.bit.b4			/* Port P14 bit */
#define		p1_5		p1.bit.b5			/* Port P15 bit */
#define		p1_6		p1.bit.b6			/* Port P16 bit */
#define		p1_7		p1.bit.b7			/* Port P17 bit */

/*------------------------------------------------------
  Port P1 direction register
------------------------------------------------------*/



#define		pd1_0		pd1.bit.b0			/* Port P10 direction bit */
#define		pd1_1		pd1.bit.b1			/* Port P11 direction bit */
#define		pd1_2		pd1.bit.b2			/* Port P12 direction bit */
#define		pd1_3		pd1.bit.b3			/* Port P13 direction bit */
#define		pd1_4		pd1.bit.b4			/* Port P14 direction bit */
#define		pd1_5		pd1.bit.b5			/* Port P15 direction bit */
#define		pd1_6		pd1.bit.b6			/* Port P16 direction bit */
#define		pd1_7		pd1.bit.b7			/* Port P17 direction bit */

/*------------------------------------------------------
  Port P2 register
------------------------------------------------------*/



#define		p2_0		p2.bit.b0			/* Port P20 bit */
#define		p2_1		p2.bit.b1			/* Port P21 bit */
#define		p2_2		p2.bit.b2			/* Port P22 bit */
#define		p2_3		p2.bit.b3			/* Port P23 bit */
#define		p2_4		p2.bit.b4			/* Port P24 bit */
#define		p2_5		p2.bit.b5			/* Port P25 bit */
#define		p2_6		p2.bit.b6			/* Port P26 bit */
#define		p2_7		p2.bit.b7			/* Port P27 bit */

/*------------------------------------------------------
  Port P2 direction register
------------------------------------------------------*/



#define		pd2_0		pd2.bit.b0			/* Port P20 direction bit */
#define		pd2_1		pd2.bit.b1			/* Port P21 direction bit */
#define		pd2_2		pd2.bit.b2			/* Port P22 direction bit */
#define		pd2_3		pd2.bit.b3			/* Port P23 direction bit */
#define		pd2_4		pd2.bit.b4			/* Port P24 direction bit */
#define		pd2_5		pd2.bit.b5			/* Port P25 direction bit */
#define		pd2_6		pd2.bit.b6			/* Port P26 direction bit */
#define		pd2_7		pd2.bit.b7			/* Port P27 direction bit */

/*------------------------------------------------------
  Port P3 register
------------------------------------------------------*/



#define		p3_0		p3.bit.b0			/* Port P30 bit */
#define		p3_1		p3.bit.b1			/* Port P31 bit */
#define		p3_3		p3.bit.b3			/* Port P33 bit */
#define		p3_4		p3.bit.b4			/* Port P34 bit */
#define		p3_5		p3.bit.b5			/* Port P35 bit */
#define		p3_7		p3.bit.b7			/* Port P37 bit */

/*------------------------------------------------------
  Port P3 direction register
------------------------------------------------------*/



#define		pd3_0		pd3.bit.b0			/* Port P30 direction bit */
#define		pd3_1		pd3.bit.b1			/* Port P31 direction bit */
#define		pd3_3		pd3.bit.b3			/* Port P33 direction bit */
#define		pd3_4		pd3.bit.b4			/* Port P34 direction bit */
#define		pd3_5		pd3.bit.b5			/* Port P35 direction bit */
#define		pd3_7		pd3.bit.b7			/* Port P37 direction bit */

/*------------------------------------------------------
  Port P4 register
------------------------------------------------------*/



#define		p4_2		p4.bit.b2			/* Port P42 bit */
#define		p4_3		p4.bit.b3			/* Port P43 bit */
#define		p4_4		p4.bit.b4			/* Port P44 bit */
#define		p4_5		p4.bit.b5			/* Port P45 bit */
#define		p4_6		p4.bit.b6			/* Port P46 bit */
#define		p4_7		p4.bit.b7			/* Port P47 bit */

/*------------------------------------------------------
  Port P4 direction register
------------------------------------------------------*/



#define		pd4_3		pd4.bit.b3			/* Port P43 direction bit */
#define		pd4_4		pd4.bit.b4			/* Port P44 direction bit */
#define		pd4_5		pd4.bit.b5			/* Port P45 direction bit */

/*------------------------------------------------------
  Port P6 register
------------------------------------------------------*/



#define		p6_0		p6.bit.b0			/* Port P60 bit */
#define		p6_1		p6.bit.b1			/* Port P61 bit */
#define		p6_2		p6.bit.b2			/* Port P62 bit */
#define		p6_3		p6.bit.b3			/* Port P63 bit */
#define		p6_4		p6.bit.b4			/* Port P64 bit */
#define		p6_5		p6.bit.b5			/* Port P65 bit */
#define		p6_6		p6.bit.b6			/* Port P66 bit */
#define		p6_7		p6.bit.b7			/* Port P67 bit */

/*------------------------------------------------------
  Port P6 direction register
------------------------------------------------------*/



#define		pd6_0		pd6.bit.b0			/* Port P60 direction bit */
#define		pd6_1		pd6.bit.b1			/* Port P61 direction bit */
#define		pd6_2		pd6.bit.b2			/* Port P62 direction bit */
#define		pd6_3		pd6.bit.b3			/* Port P63 direction bit */
#define		pd6_4		pd6.bit.b4			/* Port P64 direction bit */
#define		pd6_5		pd6.bit.b5			/* Port P65 direction bit */
#define		pd6_6		pd6.bit.b6			/* Port P66 direction bit */
#define		pd6_7		pd6.bit.b7			/* Port P67 direction bit */

/*------------------------------------------------------
  Port P2 drive capacity control register
------------------------------------------------------*/



#define		p2drr0		p2drr.bit.b0		/* P20 drive capacity */
#define		p2drr1		p2drr.bit.b1		/* P21 drive capacity */
#define		p2drr2		p2drr.bit.b2		/* P22 drive capacity */
#define		p2drr3		p2drr.bit.b3		/* P23 drive capacity */
#define		p2drr4		p2drr.bit.b4		/* P24 drive capacity */
#define		p2drr5		p2drr.bit.b5		/* P25 drive capacity */
#define		p2drr6		p2drr.bit.b6		/* P26 drive capacity */
#define		p2drr7		p2drr.bit.b7		/* P27 drive capacity */

/*------------------------------------------------------
  UART1 function select register
------------------------------------------------------*/



/*------------------------------------------------------
  Port mode register
------------------------------------------------------*/



#define		u1pinsel	pmr.bit.b4			/* Port CLK1/TXD1/RXD1 switch bit */
#define		iicsel		pmr.bit.b7			/* SSU/IIC bus switch bit */

/*------------------------------------------------------
  External input enable register
------------------------------------------------------*/



#define		int0en		inten.bit.b0		/* INT0 input enable bit */
#define		int0pl		inten.bit.b1		/* INT0 input polarity select bit */
#define		int1en		inten.bit.b2		/* INT1 input enable bit */
#define		int1pl		inten.bit.b3		/* INT1 input polarity select bit */
#define		int2en		inten.bit.b4		/* INT2 input enable bit */
#define		int2pl		inten.bit.b5		/* INT2 input polarity select bit */
#define		int3en		inten.bit.b6		/* INT3 input enable bit */
#define		int3pl		inten.bit.b7		/* INT3 input polarity select bit */

/*------------------------------------------------------
  INT0 input filter select register
------------------------------------------------------*/



#define		int0f0		intf.bit.b0		/* INT0 input filter select bit */
#define		int0f1		intf.bit.b1		/* INT0 input filter select bit */
#define		int1f0		intf.bit.b2		/* INT1 input filter select bit */
#define		int1f1		intf.bit.b3		/* INT1 input filter select bit */
#define		int2f0		intf.bit.b4		/* INT2 input filter select bit */
#define		int2f1		intf.bit.b5		/* INT2 input filter select bit */
#define		int3f0		intf.bit.b6		/* INT3 input filter select bit */
#define		int3f1		intf.bit.b7		/* INT3 input filter select bit */

/*------------------------------------------------------
  Key input enable register
------------------------------------------------------*/



#define		ki0en		kien.bit.b0		/* KI0 input enable bit */
#define		ki0pl		kien.bit.b1		/* KI0 input polarity select bit */
#define		ki1en		kien.bit.b2		/* KI1 input enable bit */
#define		ki1pl		kien.bit.b3		/* KI1 input polarity select bit */
#define		ki2en		kien.bit.b4		/* KI2 input enable bit */
#define		ki2pl		kien.bit.b5		/* KI2 input polarity select bit */
#define		ki3en		kien.bit.b6		/* KI3 input enable bit */
#define		ki3pl		kien.bit.b7		/* KI3 input polarity select bit */

/*------------------------------------------------------
  Pull-up control register0
------------------------------------------------------*/



#define		pu00		pur0.bit.b0		/* P00 to P03 pull-up */
#define		pu01		pur0.bit.b1		/* P04 to P07 pull-up */
#define		pu02		pur0.bit.b2		/* P10 to P13 pull-up */
#define		pu03		pur0.bit.b3		/* P14 to P17 pull-up */
#define		pu04		pur0.bit.b4		/* P20 to P23 pull-up */
#define		pu05		pur0.bit.b5		/* P24 to P27 pull-up */
#define		pu06		pur0.bit.b6		/* P30, P31, P33 pull-up */
#define		pu07		pur0.bit.b7		/* P34, P35, P37 pull-up */

/*------------------------------------------------------
  Pull-up control register1
------------------------------------------------------*/



#define		pu10		pur1.bit.b0		/* P43 pull-up */
#define		pu11		pur1.bit.b1		/* P44, P45 pull-up */
#define		pu14		pur1.bit.b4		/* P60 to P63 pull-up */
#define		pu15		pur1.bit.b5		/* P64 to P67 pull-up */

/*------------------------------------------------------
  Timer RA control register
------------------------------------------------------*/



#define		tstart_tracr	tracr.bit.b0	/* Timer RA count start bit */
#define		tcstf_tracr		tracr.bit.b1	/* Timer RA count status flag */
#define		tstop_tracr		tracr.bit.b2	/* Timer RA count forcible stop bit */
#define		tedgf_tracr		tracr.bit.b4	/* Active edge judgment flag */
#define		tundf_tracr		tracr.bit.b5	/* Timer RA underflow flag */

#define		TSTART_TRA		0
#define		TCSTF_TRA		1
#define		TSTOP_TRA		2
#define		TEDGF_TRA		3
#define		TUNDF_TRA		5

/*------------------------------------------------------
  Timer RA I/O control register
------------------------------------------------------*/



#define		tedgsel_traioc		traioc.bit.b0		/* TRAIO polarity switch bit */
#define		topcr_traioc		traioc.bit.b1		/* TRAIO output control bit */
#define		toena_traioc		traioc.bit.b2		/* TRAO output enable bit */
#define		tiosel_traioc		traioc.bit.b3		/* INT1/TRAIO select bit */
#define		tipf0_traioc		traioc.bit.b4		/* TRAIO input filter select bit */
#define		tipf1_traioc		traioc.bit.b5		/* TRAIO input filter select bit */

#define		TEDGSEL_TRA			0
#define		TOPCR_TRA			1
#define		TOENA_TRA			2
#define		TIOSEL_TRA			3
#define		TIPF0_TRA			4
#define		TIPF1_TRA			5

/*------------------------------------------------------
  Timer RA mode register
------------------------------------------------------*/



#define		tmod0_tramr		tramr.bit.b0	/* Timer RA operation mode select bit */
#define		tmod1_tramr		tramr.bit.b1	/* Timer RA operation mode select bit */
#define		tmod2_tramr		tramr.bit.b2	/* Timer RA operation mode select bit */
#define		tck0_tramr		tramr.bit.b4	/* Timer RA count source select bit */
#define		tck1_tramr		tramr.bit.b5	/* Timer RA count source select bit */
#define		tck2_tramr		tramr.bit.b6	/* Timer RA count source select bit */
#define		tckcut_tramr	tramr.bit.b7	/* Timer RA count source cutoff bit */

#define		TMOD0_TRA		0
#define		TMOD1_TRA		1
#define		TMOD2_TRA		2
#define		TCK0_TRA		4
#define		TCK1_TRA		5
#define		TCK2_TRA		6
#define		TCKCUT_TRA		7

/*------------------------------------------------------
  Timer RA prescaler register
------------------------------------------------------*/



/*------------------------------------------------------
  Timer RA register
------------------------------------------------------*/



/*------------------------------------------------------
  Timer RB control register
------------------------------------------------------*/



#define		tstart_trbcr	trbcr.bit.b0	/* Timer RB count start bit */
#define		tcstf_trbcr		trbcr.bit.b1	/* Timer RB count status flag */
#define		tstop_trbcr		trbcr.bit.b2	/* Timer RB count forcible stop bit */

/*------------------------------------------------------
  Timer RB one shot control register
------------------------------------------------------*/



#define		tosst_trbocr	trbocr.bit.b0	/* Timer RB one-shot start bit */
#define		tossp_trbocr	trbocr.bit.b1	/* Timer RB one-shot stop bit */
#define		tosstf_trbocr	trbocr.bit.b2	/* Timer RB one-shot status flag */

/*------------------------------------------------------
  Timer RB I/O control register
------------------------------------------------------*/



#define		topl_trbioc		trbioc.bit.b0	/* Timer RB output level select bit */
#define		tocnt_trbioc	trbioc.bit.b1	/* Timer RB output switch bit */
#define		inostg_trbioc	trbioc.bit.b2	/* One-shot trigger control bit */
#define		inoseg_trbioc	trbioc.bit.b3	/* One-shot trigger polarity select bit */

/*------------------------------------------------------
  Timer RB mode register
------------------------------------------------------*/



#define		tmod0_trbmr		trbmr.bit.b0	/* Timer RB operating mode select bit */
#define		tmod1_trbmr		trbmr.bit.b1	/* Timer RB operating mode select bit */
#define		twrc_trbmr		trbmr.bit.b3	/* Timer RB write control bit */
#define		tck0_trbmr		trbmr.bit.b4	/* Timer RB count source select bit */
#define		tck1_trbmr		trbmr.bit.b5	/* Timer RB count source select bit */
#define		tckcut_trbmr	trbmr.bit.b7	/* Timer RB count source cutoff bit */

/*------------------------------------------------------
  Timer RB prescaler register
------------------------------------------------------*/



/*------------------------------------------------------
  Timer RB secondary register
------------------------------------------------------*/



/*------------------------------------------------------
  Timer RB Primary Register
------------------------------------------------------*/



/*------------------------------------------------------
  Timer RE seconds data register / Timer RE counter data register
------------------------------------------------------*/



#define		sc00_tresec		tresec.bit.b0		/* 1st digit of seconds count bits */
#define		sc01_tresec		tresec.bit.b1		/* 1st digit of seconds count bits */
#define		sc02_tresec		tresec.bit.b2		/* 1st digit of seconds count bits */
#define		sc03_tresec		tresec.bit.b3		/* 1st digit of seconds count bits */
#define		sc10_tresec		tresec.bit.b4		/* 2nd digit of seconds count bits */
#define		sc11_tresec		tresec.bit.b5		/* 2nd digit of seconds count bits */
#define		sc12_tresec		tresec.bit.b6		/* 2nd digit of seconds count bits */
#define		bsy_tresec		tresec.bit.b7		/* Timer RE busy flag */

/*------------------------------------------------------
  Timer RE minutes data register / Timer RE compare data register
------------------------------------------------------*/



#define		mn00_tremin		tremin.bit.b0		/* 1st digit of minutes count bits */
#define		mn01_tremin		tremin.bit.b1		/* 1st digit of minutes count bits */
#define		mn02_tremin		tremin.bit.b2		/* 1st digit of minutes count bits */
#define		mn03_tremin		tremin.bit.b3		/* 1st digit of minutes count bits */
#define		mn10_tremin		tremin.bit.b4		/* 2nd digit of minutes count bits */
#define		mn11_tremin		tremin.bit.b5		/* 2nd digit of minutes count bits */
#define		mn12_tremin		tremin.bit.b6		/* 2nd digit of minutes count bits */
#define		bsy_tremin		tremin.bit.b7		/* Timer RE busy flag */

/*------------------------------------------------------
  Timer RE Hours Data Register
------------------------------------------------------*/



#define		hr00_trehr		trehr.bit.b0		/* 1st digit of hours count bits */
#define		hr01_trehr		trehr.bit.b1		/* 1st digit of hours count bits */
#define		hr02_trehr		trehr.bit.b2		/* 1st digit of hours count bits */
#define		hr03_trehr		trehr.bit.b3		/* 1st digit of hours count bits */
#define		hr10_trehr		trehr.bit.b4		/* 2nd digit of hours count bits */
#define		hr11_trehr		trehr.bit.b5		/* 2nd digit of hours count bits */
#define		bsy_trehr		trehr.bit.b7		/* Timer RE busy flag */

/*------------------------------------------------------
  Timer RE Days of Week Data Register
------------------------------------------------------*/



#define		wk0_trewk		trewk.bit.b0		/* Days of week count bits */
#define		wk1_trewk		trewk.bit.b1		/* Days of week count bits */
#define		wk2_trewk		trewk.bit.b2		/* Days of week count bits */
#define		bsy_trewk		trewk.bit.b7		/* Timer RE busy flag */

/*------------------------------------------------------
  Timer RE control register1
------------------------------------------------------*/



#define		tcstf_trecr1	trecr1.bit.b1		/* Timer RE count status flag */
#define		toena_trecr1	trecr1.bit.b2		/* TREO pin output enable bit */
#define		int_trecr1		trecr1.bit.b3		/* Interrupt request timing bit */
#define		trerst_trecr1	trecr1.bit.b4		/* Timer RE reset bit */
#define		pm_trecr1		trecr1.bit.b5		/* A.M. / P.M. bit */
#define		h12_h24_trecr1	trecr1.bit.b6		/* Operating mode select bit */
#define		tstart_trecr1	trecr1.bit.b7		/* Timer RE count start bit */

#define		TCSTF_TRE		1
#define		TOENA_TRE		2
#define		INT_TRE			3
#define		TRERST_TRE		4
#define		PM_TRE			5
#define		H24_TRE			6
#define		TSTART_TRE		7

/*------------------------------------------------------
  Timer RE control register2
------------------------------------------------------*/



#define		seie_trecr2		trecr2.bit.b0		/* Periodic interrupt triggered every second enable bit */
#define		mnie_trecr2		trecr2.bit.b1		/* Periodic interrupt triggered every minute enable bit */
#define		hrie_trecr2		trecr2.bit.b2		/* Periodic interrupt triggered every hour enable bit */
#define		dyie_trecr2		trecr2.bit.b3		/* Periodic interrupt triggered every day enable bit */
#define		wkie_trecr2		trecr2.bit.b4		/* Periodic interrupt triggered every week enable bit */
#define		comie_trecr2	trecr2.bit.b5		/* Compare match interrupt enable bit */

#define		SEIE_TRE		0
#define		MNIE_TRE		1
#define		HRIE_TRE		2
#define		DYIE_TRE		3
#define		WKIE_TRE		4
#define		COMIE_TRE		5

/*------------------------------------------------------
  Timer RE count source select register
------------------------------------------------------*/



#define		rcs0_trecsr		trecsr.bit.b0		/* Count source select bit */
#define		rcs1_trecsr		trecsr.bit.b1		/* Count source select bit */
#define		rcs2_trecsr		trecsr.bit.b2		/* 4-Bit counter select bit */
#define		rcs3_trecsr		trecsr.bit.b3		/* Real-Time clock mode select bit */
#define		rcs5_trecsr		trecsr.bit.b5		/* Clock output select bit */
#define		rcs6_trecsr		trecsr.bit.b6		/* Clock output select bit */

#define		RCS0_TRE		0
#define		RCS1_TRE		1
#define		RCS2_TRE		2
#define		RCS3_TRE		3
#define		RCS5_TRE		5
#define		RCS6_TRE		6

/*------------------------------------------------------
  Timer RD start register
------------------------------------------------------*/



#define		tstart0_trdstr	trdstr.bit.b0	/* TRD0 count start bit */
#define		tstart1_trdstr	trdstr.bit.b1	/* TRD1 count start bit */
#define		csel0_trdstr	trdstr.bit.b2	/* TRD0 count operation select bit */
#define		csel1_trdstr	trdstr.bit.b3	/* TRD1 count operation select bit */

#define		tstop0_trdstr	csel0_trdstr
#define		tstop1_trdstr	csel1_trdstr


#define		TSTART0_TRD		0
#define		TSTART1_TRD		1
#define		CSEL0_TRD		2
#define		CSEL1_TRD		3

#define		TSTOP0_TRD		2
#define		TSTOP1_TRD		3

/*------------------------------------------------------
  Timer RD mode register
------------------------------------------------------*/



#define		sync_trdmr		trdmr.bit.b0	/* Timer RD synchronous bit */
#define		bfc0_trdmr		trdmr.bit.b4	/* TRDGRC0 register function selection bit */
#define		bfd0_trdmr		trdmr.bit.b5	/* TRDGRD0 register function selection bit */
#define		bfc1_trdmr		trdmr.bit.b6	/* TRDGRC1 register function selection bit */
#define		bfd1_trdmr		trdmr.bit.b7	/* TRDGRD1 register function selection bit */

#define		trdmdr			trdmr
#define		sync_trdmdr		sync_trdmr
#define		bfc0_trdmdr		bfc0_trdmr
#define		bfd0_trdmdr		bfd0_trdmr
#define		bfc1_trdmdr		bfc1_trdmr
#define		bfd1_trdmdr		bfd1_trdmr

#define		SYNC_TRD		0
#define		BFC0_TRD		4
#define		BFD0_TRD		5
#define		BFC1_TRD		6
#define		BFD1_TRD		7

/*------------------------------------------------------
  Timer RD PWM mode register
------------------------------------------------------*/



#define		pwmb0_trdpmr	trdpmr.bit.b0	/* PWM mode of TRDIOB0 selection bit */
#define		pwmc0_trdpmr	trdpmr.bit.b1	/* PWM mode of TRDIOC0 selection bit */
#define		pwmd0_trdpmr	trdpmr.bit.b2	/* PWM mode of TRDIOD0 selection bit */
#define		pwmb1_trdpmr	trdpmr.bit.b4	/* PWM mode of TRDIOB1 selection bit */
#define		pwmc1_trdpmr	trdpmr.bit.b5	/* PWM mode of TRDIOC1 selection bit */
#define		pwmd1_trdpmr	trdpmr.bit.b6	/* PWM mode of TRDIOD1 selection bit */

#define		PWMB0_TRD		0
#define		PWMC0_TRD		1
#define		PWMD0_TRD		2
#define		PWMB1_TRD		4
#define		PWMC1_TRD		5
#define		PWMD1_TRD		6

/*------------------------------------------------------
  Timer RD function control register
------------------------------------------------------*/



#define		cmd0_trdfcr		trdfcr.bit.b0	/* Combination mode selection bit */
#define		cmd1_trdfcr		trdfcr.bit.b1	/* Combination mode selection bit */
#define		ols0_trdfcr		trdfcr.bit.b2	/* Normal-Phase output level selection bit */
#define		ols1_trdfcr		trdfcr.bit.b3	/* Counter-Phase output level selection bit */
#define		adtrg_trdfcr	trdfcr.bit.b4	/* A/D trigger enable bit */
#define		adeg_trdfcr		trdfcr.bit.b5	/* A/D trigger edge selection bit */
#define		stclk_trdfcr	trdfcr.bit.b6	/* External clock input selection bit */
#define		pwm3_trdfcr		trdfcr.bit.b7	/* PWM3 mode selection bit */

#define		CMD0_TRD		0
#define		CMD1_TRD		1
#define		OLS0_TRD		2
#define		OLS1_TRD		3
#define		ADTRG_TRD		4
#define		ADEG_TRD		5
#define		STCLK_TRD		6
#define		PWM3_TRD		7

/*------------------------------------------------------
  Timer RD output master enable register 1
------------------------------------------------------*/



#define		ea0_trdoer1		trdoer1.bit.b0	/* TRDIOA0 output disable bit */
#define		eb0_trdoer1		trdoer1.bit.b1	/* TRDIOB0 output disable bit */
#define		ec0_trdoer1		trdoer1.bit.b2	/* TRDIOC0 output disable bit */
#define		ed0_trdoer1		trdoer1.bit.b3	/* TRDIOD0 output disable bit */
#define		ea1_trdoer1		trdoer1.bit.b4	/* TRDIOA1 output disable bit */
#define		eb1_trdoer1		trdoer1.bit.b5	/* TRDIOB1 output disable bit */
#define		ec1_trdoer1		trdoer1.bit.b6	/* TRDIOC1 output disable bit */
#define		ed1_trdoer1		trdoer1.bit.b7	/* TRDIOD1 output disable bit */

#define		EA0_TRD			0
#define		EB0_TRD			1
#define		EC0_TRD			2
#define		ED0_TRD			3
#define		EA1_TRD			4
#define		EB1_TRD			5
#define		EC1_TRD			6
#define		ED1_TRD			7

/*------------------------------------------------------
  Timer RD output master enable register 2
------------------------------------------------------*/



#define		pto_trdoer2		trdoer2.bit.b7	/* INT0 of pulse output forced cutoff signal input enabled bit */

#define		PTO_TRD			7

/*------------------------------------------------------
  Timer RD output control register
------------------------------------------------------*/



#define		toa0_trdocr		trdocr.bit.b0	/* TRDIOA0 output level selection bit */
#define		tob0_trdocr		trdocr.bit.b1	/* TRDIOB0 output level selection bit */
#define		toc0_trdocr		trdocr.bit.b2	/* TRDIOC0 initial output level selection bit */
#define		tod0_trdocr		trdocr.bit.b3	/* TRDIOD0 initial output level selection bit */
#define		toa1_trdocr		trdocr.bit.b4	/* TRDIOA1 initial output level selection bit */
#define		tob1_trdocr		trdocr.bit.b5	/* TRDIOB1 initial output level selection bit */
#define		toc1_trdocr		trdocr.bit.b6	/* TRDIOC1 initial output level selection bit */
#define		tod1_trdocr		trdocr.bit.b7	/* TRDIOD1 initial output level selection bit */

#define		TOA0_TRD		0
#define		TOB0_TRD		1
#define		TOC0_TRD		2
#define		TOD0_TRD		3
#define		TOA1_TRD		4
#define		TOB1_TRD		5
#define		TOC1_TRD		6
#define		TOD1_TRD		7

/*------------------------------------------------------
  Timer RD digital filter function selection register 0
------------------------------------------------------*/



#define		dfa_trddf0		trddf0.bit.b0	/* TRDIOA pin digital filter function selection bit */
#define		dfb_trddf0		trddf0.bit.b1	/* TRDIOB pin digital filter function selection bit */
#define		dfc_trddf0		trddf0.bit.b2	/* TRDIOC pin digital filter function selection bit */
#define		dfd_trddf0		trddf0.bit.b3	/* TRDIOD pin digital filter function selection bit */
#define		dfck0_trddf0	trddf0.bit.b6	/* Clock selection bit for digital filter function */
#define		dfck1_trddf0	trddf0.bit.b7	/* Clock selection bit for digital filter function */

#define		DFA_TRD			0
#define		DFB_TRD			1
#define		DFC_TRD			2
#define		DFD_TRD			3
#define		DFCK0_TRD		6
#define		DFCK1_TRD		7


/*------------------------------------------------------
  Timer RD digital filter function selection register 1
------------------------------------------------------*/



#define		dfa_trddf1		trddf1.bit.b0	/* TRDIOA pin digital filter function selection bit */
#define		dfb_trddf1		trddf1.bit.b1	/* TRDIOB pin digital filter function selection bit */
#define		dfc_trddf1		trddf1.bit.b2	/* TRDIOC pin digital filter function selection bit */
#define		dfd_trddf1		trddf1.bit.b3	/* TRDIOD pin digital filter function selection bit */
#define		dfck0_trddf1	trddf1.bit.b6	/* Clock selection bit for digital filter function */
#define		dfck1_trddf1	trddf1.bit.b7	/* Clock selection bit for digital filter function */

/*------------------------------------------------------
  Timer RD control register 0
------------------------------------------------------*/



#define		tck0_trdcr0		trdcr0.bit.b0	/* Count source selection bit */
#define		tck1_trdcr0		trdcr0.bit.b1	/* Count source selection bit */
#define		tck2_trdcr0		trdcr0.bit.b2	/* Count source selection bit */
#define		tpsc0_trdcr0	tck0_trdcr0
#define		tpsc1_trdcr0	tck1_trdcr0
#define		tpsc2_trdcr0	tck2_trdcr0
#define		ckeg0_trdcr0	trdcr0.bit.b3	/* External clock edge selection bit */
#define		ckeg1_trdcr0	trdcr0.bit.b4	/* External clock edge selection bit */
#define		cclr0_trdcr0	trdcr0.bit.b5	/* TRD0 counter clear selection bit */
#define		cclr1_trdcr0	trdcr0.bit.b6	/* TRD0 counter clear selection bit */
#define		cclr2_trdcr0	trdcr0.bit.b7	/* TRD0 counter clear selection bit */


/*------------------------------------------------------
  Timer RD control register 1
------------------------------------------------------*/



#define		tck0_trdcr1		trdcr1.bit.b0	/* Count source selection bit */
#define		tck1_trdcr1		trdcr1.bit.b1	/* Count source selection bit */
#define		tck2_trdcr1		trdcr1.bit.b2	/* Count source selection bit */
#define		tpsc0_trdcr1	tck0_trdcr1
#define		tpsc1_trdcr1	tck1_trdcr1
#define		tpsc2_trdcr1	tck2_trdcr1
#define		ckeg0_trdcr1	trdcr1.bit.b3	/* External clock edge selection bit */
#define		ckeg1_trdcr1	trdcr1.bit.b4	/* External clock edge selection bit */
#define		cclr0_trdcr1	trdcr1.bit.b5	/* TRD1 counter clear selection bit */
#define		cclr1_trdcr1	trdcr1.bit.b6	/* TRD1 counter clear selection bit */
#define		cclr2_trdcr1	trdcr1.bit.b7	/* TRD1 counter clear selection bit */

#define		TCK0_TRD		0
#define		TCK1_TRD		1
#define		TCK2_TRD		2

#define		TPSC0_TRD		0
#define		TPSC1_TRD		1
#define		TPSC2_TRD		2

#define		CKEG0_TRD		3
#define		CKEG1_TRD		4
#define		CCLR0_TRD		5
#define		CCLR1_TRD		6
#define		CCLR2_TRD		7


/*------------------------------------------------------
  Timer RD I/O control register A0
------------------------------------------------------*/



#define		ioa0_trdiora0	trdiora0.bit.b0	/* TRDGRA control bit */
#define		ioa1_trdiora0	trdiora0.bit.b1	/* TRDGRA control bit */
#define		ioa2_trdiora0	trdiora0.bit.b2	/* TRDGRA mode selection bit */
#define		ioa3_trdiora0	trdiora0.bit.b3	/* Input capture input switch bit */
#define		iob0_trdiora0	trdiora0.bit.b4	/* TRDGRB control bit */
#define		iob1_trdiora0	trdiora0.bit.b5	/* TRDGRB control bit */
#define		iob2_trdiora0	trdiora0.bit.b6	/* TRDGRB mode selection bit */

#define		IOA0_TRD		0
#define		IOA1_TRD		1
#define		IOA2_TRD		2
#define		IOA3_TRD		3
#define		IOB0_TRD		4
#define		IOB1_TRD		5
#define		IOB2_TRD		6

/*------------------------------------------------------
  Timer RD I/O control register A1
------------------------------------------------------*/



#define		ioa0_trdiora1	trdiora1.bit.b0	/* TRDGRA control bit */
#define		ioa1_trdiora1	trdiora1.bit.b1	/* TRDGRA control bit */
#define		ioa2_trdiora1	trdiora1.bit.b2	/* TRDGRA mode selection bit */
#define		ioa3_trdiora1	trdiora1.bit.b3	/* Input capture input switch bit */
#define		iob0_trdiora1	trdiora1.bit.b4	/* TRDGRB control bit */
#define		iob1_trdiora1	trdiora1.bit.b5	/* TRDGRB control bit */
#define		iob2_trdiora1	trdiora1.bit.b6	/* TRDGRB mode selection bit */

/*------------------------------------------------------
  Timer RD I/O control register C0
------------------------------------------------------*/



#define		ioc0_trdiorc0	trdiorc0.bit.b0	/* TRDGRC control bit */
#define		ioc1_trdiorc0	trdiorc0.bit.b1	/* TRDGRC control bit */
#define		ioc2_trdiorc0	trdiorc0.bit.b2	/* TRDGRC mode selection bit */
#define		ioc3_trdiorc0	trdiorc0.bit.b3	/* TRDGRC register function selection bit */
#define		iod0_trdiorc0	trdiorc0.bit.b4	/* TRDGRD control bit */
#define		iod1_trdiorc0	trdiorc0.bit.b5	/* TRDGRD control bit */
#define		iod2_trdiorc0	trdiorc0.bit.b6	/* TRDGRD mode selection bit */
#define		iod3_trdiorc0	trdiorc0.bit.b7	/* TRDGRD register function selection bit */

#define		IOC0_TRD		0
#define		IOC1_TRD		1
#define		IOC2_TRD		2
#define		IOC3_TRD		3
#define		IOD0_TRD		4
#define		IOD1_TRD		5
#define		IOD2_TRD		6
#define		IOD3_TRD		7

/*------------------------------------------------------
  Timer RD I/O control register C1
------------------------------------------------------*/



#define		ioc0_trdiorc1	trdiorc1.bit.b0	/* TRDGRC control bit */
#define		ioc1_trdiorc1	trdiorc1.bit.b1	/* TRDGRC control bit */
#define		ioc2_trdiorc1	trdiorc1.bit.b2	/* TRDGRC mode selection bit */
#define		ioc3_trdiorc1	trdiorc1.bit.b3	/* TRDGRC register function selection bit */
#define		iod0_trdiorc1	trdiorc1.bit.b4	/* TRDGRD control bit */
#define		iod1_trdiorc1	trdiorc1.bit.b5	/* TRDGRD control bit */
#define		iod2_trdiorc1	trdiorc1.bit.b6	/* TRDGRD mode selection bit */
#define		iod3_trdiorc1	trdiorc1.bit.b7	/* TRDGRD register function selection bit */

/*------------------------------------------------------
  Timer RD status register 0
------------------------------------------------------*/



#define		imfa_trdsr0		trdsr0.bit.b0	/* Input capture / compare match flag A */
#define		imfb_trdsr0		trdsr0.bit.b1	/* Input capture / compare match flag B */
#define		imfc_trdsr0		trdsr0.bit.b2	/* Input capture / compare match flag C */
#define		imfd_trdsr0		trdsr0.bit.b3	/* Input capture / compare match flag D */
#define		ovf_trdsr0		trdsr0.bit.b4	/* Overflow flag */


/*------------------------------------------------------
  Timer RD status register 1
------------------------------------------------------*/



#define		imfa_trdsr1		trdsr1.bit.b0	/* Input capture / compare match flag A */
#define		imfb_trdsr1		trdsr1.bit.b1	/* Input capture / compare match flag B */
#define		imfc_trdsr1		trdsr1.bit.b2	/* Input capture / compare match flag C */
#define		imfd_trdsr1		trdsr1.bit.b3	/* Input capture / compare match flag D */
#define		ovf_trdsr1		trdsr1.bit.b4	/* Overflow flag */
#define		udf_trdsr1		trdsr1.bit.b5	/* Underflow flag */

#define		IMFA_TRD		0
#define		IMFB_TRD		1
#define		IMFC_TRD		2
#define		IMFD_TRD		3
#define		OVF_TRD			4
#define		UDF_TRD			5


/*------------------------------------------------------
  Timer RD interrupt enable register 0
------------------------------------------------------*/



#define		imiea_trdier0	trdier0.bit.b0	/* Input capture / compare match interrupt enable bit A */
#define		imieb_trdier0	trdier0.bit.b1	/* Input capture / compare match interrupt enable bit B */
#define		imiec_trdier0	trdier0.bit.b2	/* Input capture / compare match interrupt enable bit C */
#define		imied_trdier0	trdier0.bit.b3	/* Input capture / compare match interrupt enable bit D */
#define		ovie_trdier0	trdier0.bit.b4	/* Overflow / underflow interrupt enable bit */


/*------------------------------------------------------
  Timer RD interrupt enable register 1
------------------------------------------------------*/



#define		imiea_trdier1	trdier1.bit.b0	/* Input capture / compare match interrupt enable bit A */
#define		imieb_trdier1	trdier1.bit.b1	/* Input capture / compare match interrupt enable bit B */
#define		imiec_trdier1	trdier1.bit.b2	/* Input capture / compare match interrupt enable bit C */
#define		imied_trdier1	trdier1.bit.b3	/* Input capture / compare match interrupt enable bit D */
#define		ovie_trdier1	trdier1.bit.b4	/* Overflow / underflow interrupt enable bit */

#define		IMIEA_TRD		0
#define		IMIEB_TRD		1
#define		IMIEC_TRD		2
#define		IMIED_TRD		3
#define		OVIE_TRD		4


/*------------------------------------------------------
  Timer RD PWM mode output level control register 0
------------------------------------------------------*/



#define		polb_trdpocr0	trdpocr0.bit.b0	/* PWM mode output level control bit B */
#define		polc_trdpocr0	trdpocr0.bit.b1	/* PWM mode output level control bit C */
#define		pold_trdpocr0	trdpocr0.bit.b2	/* PWM mode output level control bit D */

#define		POLB_TRD		0
#define		POLC_TRD		1
#define		POLD_TRD		2

/*------------------------------------------------------
  Timer RD PWM mode output level control register 1
------------------------------------------------------*/



#define		polb_trdpocr1	trdpocr1.bit.b0	/* PWM mode output level control bit B */
#define		polc_trdpocr1	trdpocr1.bit.b1	/* PWM mode output level control bit C */
#define		pold_trdpocr1	trdpocr1.bit.b2	/* PWM mode output level control bit D */

/*------------------------------------------------------
  Timer RD Counter , Timer RD general register A,B,C,D
------------------------------------------------------*/
//unsigned short trd0, trdgra0, trdgrb0, trdgrc0, trdgrd0;
//unsigned short trd1, trdgra1, trdgrb1, trdgrc1, trdgrd1;


/*------------------------------------------------------
  LIN control register
------------------------------------------------------*/



#define		sfie_lincr		lincr.bit.b0	/* Synchronous field measurementcompleted interrupt enable bit */
#define		sbie_lincr		lincr.bit.b1	/* Synchronous break detection interrupt enable bit */
#define		bcie_lincr		lincr.bit.b2	/* Bus collision detection interrupt enable bit */
#define		rxdsf_lincr		lincr.bit.b3	/* RxD0 input status flag */
#define		lstart_lincr	lincr.bit.b4	/* Synchronous Break detection start bit */
#define		sbe_lincr		lincr.bit.b5	/* RxD0 input unmasking timing select bit */
#define		mst_lincr		lincr.bit.b6	/* LIN operation mode setting bit */
#define		line_lincr		lincr.bit.b7	/* LIN operation start bit */

/*------------------------------------------------------
  LIN status register
------------------------------------------------------*/



#define		sfdct_linst	linst.bit.b0		/* Synchronous field measurementcompleted flag */
#define		sbdct_linst	linst.bit.b1		/* Synchronous break detection flag */
#define		bcdct_linst	linst.bit.b2		/* Bus collision detection flag */
#define		b0clr_linst	linst.bit.b3		/* SFDCT flag clear bit */
#define		b1clr_linst	linst.bit.b4		/* SBDCT flag clear bit */
#define		b2clr_linst	linst.bit.b5		/* BCDCT flag clear bit */

/*------------------------------------------------------
  Flash mamory control register4
------------------------------------------------------*/



#define		fmr40		fmr4.bit.b0		/* Erase-suspend function enable bit */
#define		fmr41		fmr4.bit.b1		/* Erase-suspend request bit */
#define		fmr42		fmr4.bit.b2		/* Program-suspend request bit */
#define		fmr43		fmr4.bit.b3		/* Erase command flag */
#define		fmr44		fmr4.bit.b4		/* Program command flag */
#define		fmr46		fmr4.bit.b6		/* Read status flag */
#define		fmr47		fmr4.bit.b7		/* Low-Power consumption read mode enable bit */

/*------------------------------------------------------
  Flash mamory control register1
------------------------------------------------------*/



#define		fmr11		fmr1.bit.b1		/* EW1 mode select bit */
#define		fmr15		fmr1.bit.b5		/* Block0 rewrite disable bit */
#define		fmr16		fmr1.bit.b6		/* Block1 rewrite disable bit */

/*------------------------------------------------------
  Flash mamory control register0
------------------------------------------------------*/



#define		fmr00		fmr0.bit.b0		/* RY/BY status flag */
#define		fmr01		fmr0.bit.b1		/* CPU rewrite mode select bit */
#define		fmr02		fmr0.bit.b2		/* Block 0, 1 rew rite enable bit */
#define		fmstp		fmr0.bit.b3		/* Flash memory stop bit */
#define		fmr06		fmr0.bit.b6		/* Program status flag  */
#define		fmr07		fmr0.bit.b7		/* Erase status flag */

/*------------------------------------------------------
  Interrupt control register
------------------------------------------------------*/
union intcr{
	struct{
		char	ilvl0:1;						/* Interrupt priority level select bit */
		char	ilvl1:1;						/* Interrupt priority level select bit */
		char	ilvl2:1;						/* Interrupt priority level select bit */
		char	ir:1;							/* Interrupt request bit */
		char	pol:1;							/* Polarity switch bit */
		char	b5:1;
		char	b6:1;
		char	b7:1;
	} bit;
	char	byte;
};

/*------------------------------------------------------
  Timer RD 0  interrupt control register
------------------------------------------------------*/


#define		ilvl0_trd0ic	trd0ic.bit.ilvl0
#define		ilvl1_trd0ic	trd0ic.bit.ilvl1
#define		ilvl2_trd0ic	trd0ic.bit.ilvl2
#define		ir_trd0ic		trd0ic.bit.ir

/*------------------------------------------------------
  Timer RD 1  interrupt control register
------------------------------------------------------*/


#define		ilvl0_trd1ic	trd1ic.bit.ilvl0
#define		ilvl1_trd1ic	trd1ic.bit.ilvl1
#define		ilvl2_trd1ic	trd1ic.bit.ilvl2
#define		ir_trd1ic		trd1ic.bit.ir

/*------------------------------------------------------
  Timer RE  interrupt control register
------------------------------------------------------*/


#define		ilvl0_treic		treic.bit.ilvl0
#define		ilvl1_treic		treic.bit.ilvl1
#define		ilvl2_treic		treic.bit.ilvl2
#define		ir_treic		treic.bit.ir

/*------------------------------------------------------
  Key input interrupt control register
------------------------------------------------------*/


#define		ilvl0_kupic		kupic.bit.ilvl0
#define		ilvl1_kupic		kupic.bit.ilvl1
#define		ilvl2_kupic		kupic.bit.ilvl2
#define		ir_kupic		kupic.bit.ir

/*------------------------------------------------------
  A-D interrupt control register
------------------------------------------------------*/


#define		ilvl0_adic		adic.bit.ilvl0
#define		ilvl1_adic		adic.bit.ilvl1
#define		ilvl2_adic		adic.bit.ilvl2
#define		ir_adic			adic.bit.ir

/*------------------------------------------------------
  SSU interrupt control register
------------------------------------------------------*/


#define		ilvl0_ssuaic	ssuaic.bit.ilvl0
#define		ilvl1_ssuaic	ssuaic.bit.ilvl1
#define		ilvl2_ssuaic	ssuaic.bit.ilvl2
#define		ir_ssuaic		ssuaic.bit.ir

/*------------------------------------------------------
  IIC interrupt control register
------------------------------------------------------*/


#define		ilvl0_iic2aic	iic2aic.bit.ilvl0
#define		ilvl1_iic2aic	iic2aic.bit.ilvl1
#define		ilvl2_iic2aic	iic2aic.bit.ilvl2
#define		ir_iic2aic		iic2aic.bit.ir

/*------------------------------------------------------
  UART0 transmit interrupt control register
------------------------------------------------------*/


#define		ilvl0_s0tic		s0tic.bit.ilvl0
#define		ilvl1_s0tic		s0tic.bit.ilvl1
#define		ilvl2_s0tic		s0tic.bit.ilvl2
#define		ir_s0tic		s0tic.bit.ir

/*------------------------------------------------------
  UART0 receive interrupt control register
------------------------------------------------------*/


#define		ilvl0_s0ric		s0ric.bit.ilvl0
#define		ilvl1_s0ric		s0ric.bit.ilvl1
#define		ilvl2_s0ric		s0ric.bit.ilvl2
#define		ir_s0ric		s0ric.bit.ir

/*------------------------------------------------------
  UART1 transmit interrupt control register
------------------------------------------------------*/


#define		ilvl0_s1tic		s1tic.bit.ilvl0
#define		ilvl1_s1tic		s1tic.bit.ilvl1
#define		ilvl2_s1tic		s1tic.bit.ilvl2
#define		ir_s1tic		s1tic.bit.ir

/*------------------------------------------------------
  UART1 receive interrupt control register
------------------------------------------------------*/


#define		ilvl0_s1ric		s1ric.bit.ilvl0
#define		ilvl1_s1ric		s1ric.bit.ilvl1
#define		ilvl2_s1ric		s1ric.bit.ilvl2
#define		ir_s1ric		s1ric.bit.ir

/*------------------------------------------------------
  INT2 interrupt control register
------------------------------------------------------*/


#define		ilvl0_int2ic	int2ic.bit.ilvl0
#define		ilvl1_int2ic	int2ic.bit.ilvl1
#define		ilvl2_int2ic	int2ic.bit.ilvl2
#define		ir_int2ic		int2ic.bit.ir
#define		pol_int2ic		int2ic.bit.pol

/*------------------------------------------------------
  Timer RA interrupt control register
------------------------------------------------------*/


#define		ilvl0_traic		traic.bit.ilvl0
#define		ilvl1_traic		traic.bit.ilvl1
#define		ilvl2_traic		traic.bit.ilvl2
#define		ir_traic		traic.bit.ir

/*------------------------------------------------------
  Timer RB interrupt control register
------------------------------------------------------*/


#define		ilvl0_trbic		trbic.bit.ilvl0
#define		ilvl1_trbic		trbic.bit.ilvl1
#define		ilvl2_trbic		trbic.bit.ilvl2
#define		ir_trbic		trbic.bit.ir

/*------------------------------------------------------
  INT1 interrupt control register
------------------------------------------------------*/


#define		ilvl0_int1ic	int1ic.bit.ilvl0
#define		ilvl1_int1ic	int1ic.bit.ilvl1
#define		ilvl2_int1ic	int1ic.bit.ilvl2
#define		ir_int1ic		int1ic.bit.ir
#define		pol_int1ic		int1ic.bit.pol

/*------------------------------------------------------
  INT3 interrupt control register
------------------------------------------------------*/


#define		ilvl0_int3ic	int3ic.bit.ilvl0
#define		ilvl1_int3ic	int3ic.bit.ilvl1
#define		ilvl2_int3ic	int3ic.bit.ilvl2
#define		ir_int3ic		int3ic.bit.ir
#define		pol_int3ic		int3ic.bit.pol

/*------------------------------------------------------
  INT0 interrupt control register
------------------------------------------------------*/


#define		ilvl0_int0ic	int0ic.bit.ilvl0
#define		ilvl1_int0ic	int0ic.bit.ilvl1
#define		ilvl2_int0ic	int0ic.bit.ilvl2
#define		ir_int0ic		int0ic.bit.ir
#define		pol_int0ic		int0ic.bit.pol

/*------------------------------------------------------
  UARTi transmit/receive mode register
------------------------------------------------------*/
union uimr{
	struct{
		char	smd0:1;							/* Serial I/O mode select bit */
		char	smd1:1;							/* Serial I/O mode select bit */
		char	smd2:1;							/* Serial I/O mode select bit */
		char	ckdir:1;						/* Internal/external clock select bit */
		char	stps:1;							/* Stop bit length select bit */
		char	pry:1;							/* Odd/even parity select bit */
		char	prye:1;							/* Parity enable bit */
		char	b7:1;
	} bit;
	char	byte;
};

/*------------------------------------------------------
  UARTi transmit/receive mode register
------------------------------------------------------*/


#define		smd0_u0mr		u0mr.bit.smd0	/* Serial I/O mode select bit */
#define		smd1_u0mr		u0mr.bit.smd1	/* Serial I/O mode select bit */
#define		smd2_u0mr		u0mr.bit.smd2	/* Serial I/O mode select bit */
#define		ckdir_u0mr		u0mr.bit.ckdir	/* Internal/external clock select bit */
#define		stps_u0mr		u0mr.bit.stps	/* Stop bit length select bit */
#define		pry_u0mr		u0mr.bit.pry	/* Odd/even parity select bit */
#define		prye_u0mr		u0mr.bit.prye	/* Parity enable bit */


#define		smd0_u1mr		u1mr.bit.smd0	/* Serial I/O mode select bit */
#define		smd1_u1mr		u1mr.bit.smd1	/* Serial I/O mode select bit */
#define		smd2_u1mr		u1mr.bit.smd2	/* Serial I/O mode select bit */
#define		ckdir_u1mr		u1mr.bit.ckdir	/* Internal/external clock select bit */
#define		stps_u1mr		u1mr.bit.stps	/* Stop bit length select bit */
#define		pry_u1mr		u1mr.bit.pry	/* Odd/even parity select bit */
#define		prye_u1mr		u1mr.bit.prye	/* Parity enable bit */


#define		smd0_u2mr		u2mr.bit.smd0	/* Serial I/O mode select bit */
#define		smd1_u2mr		u2mr.bit.smd1	/* Serial I/O mode select bit */
#define		smd2_u2mr		u2mr.bit.smd2	/* Serial I/O mode select bit */
#define		ckdir_u2mr		u2mr.bit.ckdir	/* Internal/external clock select bit */
#define		stps_u2mr		u2mr.bit.stps	/* Stop bit length select bit */
#define		pry_u2mr		u2mr.bit.pry	/* Odd/even parity select bit */
#define		prye_u2mr		u2mr.bit.prye	/* Parity enable bit */

/*------------------------------------------------------
  UARTi transmit/receive control register0
------------------------------------------------------*/
union uic0{
	struct{
		char	clk0:1;							/* BRG count source select bit */
		char	clk1:1;							/* BRG count source select bit */
		char	b2:1;
		char	txept:1;						/* Transmit register empty flag */
		char	b4:1;
		char	nch:1;							/* Data output select bit */
		char	ckpol:1;						/* CLK polarity select bit */
		char	uform:1;						 /* Transfer format select bit */
	} bit;
	char	byte;
};

/*------------------------------------------------------
  UARTi transmit/receive control register0
------------------------------------------------------*/


#define		clk0_u0c0		u0c0.bit.clk0	/* BRG count source select bit */
#define		clk1_u0c0		u0c0.bit.clk1	/* BRG count source select bit */
#define		txept_u0c0		u0c0.bit.txept	/* Transmit register empty flag */
#define		nch_u0c0		u0c0.bit.nch	/* Data output select bit */
#define		ckpol_u0c0		u0c0.bit.ckpol	/* CLK polarity select bit */
#define		uform_u0c0		u0c0.bit.uform	/* Transfer format select bit */


#define		clk0_u1c0		u1c0.bit.clk0	/* BRG count source select bit */
#define		clk1_u1c0		u1c0.bit.clk1	/* BRG count source select bit */
#define		txept_u1c0		u1c0.bit.txept	/* Transmit register empty flag */
#define		nch_u1c0		u1c0.bit.nch	/* Data output select bit */
#define		ckpol_u1c0		u1c0.bit.ckpol	/* CLK polarity select bit */
#define		uform_u1c0		u1c0.bit.uform	/* Transfer format select bit */


#define		clk0_u2c0		u2c0.bit.clk0	/* BRG count source select bit */
#define		clk1_u2c0		u2c0.bit.clk1	/* BRG count source select bit */
#define		txept_u2c0		u2c0.bit.txept	/* Transmit register empty flag */
#define		nch_u2c0		u2c0.bit.nch	/* Data output select bit */
#define		ckpol_u2c0		u2c0.bit.ckpol	/* CLK polarity select bit */
#define		uform_u2c0		u2c0.bit.uform	/* Transfer format select bit */

/*------------------------------------------------------
  UARTi transmit/receive control register1
------------------------------------------------------*/
union uic1{
	struct{
		char	te:1;							/* Transmit enable bit */
		char	ti:1;							/* Transmit buffer empty flag */
		char	re:1;							/* Receive enable bit */
		char	ri:1;							/* Receive complete flag */
		char	irs:1;
		char	rrm:1;
		char	b6:1;
		char	b7:1;
	} bit;
	char	byte;
};

/*------------------------------------------------------
  UARTi transmit/receive control register1
------------------------------------------------------*/


#define		te_u0c1			u0c1.bit.te	/* Transmit enable bit */
#define		ti_u0c1			u0c1.bit.ti	/* Transmit buffer empty flag */
#define		re_u0c1			u0c1.bit.re	/* Receive enable bit */
#define		ri_u0c1			u0c1.bit.ri	/* Receive complete flag */
#define		u0irs_u0c1		u0c1.bit.irs	/* UART0 transmit interrupt cause select bit */
#define		u0rrm_u0c1		u0c1.bit.rrm	/* UART0 continuous receive mode enable bit */


#define		te_u1c1			u1c1.bit.te	/* Transmit enable bit */
#define		ti_u1c1			u1c1.bit.ti	/* Transmit buffer empty flag */
#define		re_u1c1			u1c1.bit.re	/* Receive enable bit */
#define		ri_u1c1			u1c1.bit.ri	/* Receive complete flag */
#define		u1irs_u1c1		u1c1.bit.irs	/* UART1 transmit interrupt cause select bit */
#define		u1rrm_u1c1		u1c1.bit.rrm	/* UART1 continuous receive mode enable bit */


#define		te_u2c1			u2c1.bit.te	/* Transmit enable bit */
#define		ti_u2c1			u2c1.bit.ti	/* Transmit buffer empty flag */
#define		re_u2c1			u2c1.bit.re	/* Receive enable bit */
#define		ri_u2c1			u2c1.bit.ri	/* Receive complete flag */
#define		u1irs_u2c1		u2c1.bit.irs	/* UART1 transmit interrupt cause select bit */
#define		u1rrm_u2c1		u2c1.bit.rrm	/* UART1 continuous receive mode enable bit */

/*------------------------------------------------------
  UARTi receive buffer register
------------------------------------------------------*/
union uirb{
	struct{
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
		char	b8:1;
		char	b9:1;
		char	b10:1;
		char	b11:1;
		char	oer:1;							/* Overrun error flag */
		char	fer:1;							/* Framing error flag */
		char	per:1;							/* Parity error flag */
		char	sum:1;							/* Error sum flag */
	} bit;
	struct{
		char	low;							/* Low  8 bit */
		char	high;							/* High 8 bit */
	} byte;
	unsigned short	word;
};

/*------------------------------------------------------
  UARTi receive buffer register
------------------------------------------------------*/

#define		u0rbl		u0rb.byte.low
#define		u0rbh		u0rb.byte.high

#define		oer_u0rb	u0rb.bit.oer		/* Overrun error flag */
#define		fer_u0rb	u0rb.bit.fer		/* Framing error flag */
#define		per_u0rb	u0rb.bit.per		/* Parity error flag */
#define		sum_u0rb	u0rb.bit.sum		/* Error sum flag */


#define		u1rbl		u1rb.byte.low
#define		u1rbh		u1rb.byte.high

#define		oer_u1rb	u1rb.bit.oer		/* Overrun error flag */
#define		fer_u1rb	u1rb.bit.fer		/* Framing error flag */
#define		per_u1rb	u1rb.bit.per		/* Parity error flag */
#define		sum_u1rb	u1rb.bit.sum		/* Error sum flag */


#define		u2rbl		u2rb.byte.low
#define		u2rbh		u2rb.byte.high

#define		oer_u2rb	u2rb.bit.oer		/* Overrun error flag */
#define		fer_u2rb	u2rb.bit.fer		/* Framing error flag */
#define		per_u2rb	u2rb.bit.per		/* Parity error flag */
#define		sum_u2rb	u2rb.bit.sum		/* Error sum flag */

/********************************************************
*  declare SFR union                                    *
********************************************************/

union rmadi{
	struct{
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
		char	b8:1;
		char	b9:1;
		char	b10:1;
		char	b11:1;
		char	b12:1;
		char	b13:1;
		char	b14:1;
		char	b15:1;
		char	b16:1;
		char	b17:1;
		char	b18:1;
		char	b19:1;
	} bit;
	struct{
		char	low;							/* low  8 bit */
		char	mid;							/* mid  8 bit */
		char	high;							/* high 8 bit */
		char	nc;								/* non use */
	} byte;

	unsigned long	dword;
};

			/* Address match interrupt register0 */
#define		rmad0l		rmad0.byte.low		/* Address match interrupt register0 Low */
#define		rmad0m		rmad0.byte.mid		/* Address match interrupt register0 Middle */
#define		rmad0h		rmad0.byte.high		/* Address match interrupt register0 Hig)) */
			/* Address match interrupt register1 */
#define		rmad1l		rmad1.byte.low		/* Address match interrupt register1 Low */
#define		rmad1m		rmad1.byte.mid		/* Address match interrupt register1 Middle */
#define		rmad1h		rmad1.byte.high		/* Address match interrupt register1 High */


union worddef{
	struct{
		char	b0:1;
		char	b1:1;
		char	b2:1;
		char	b3:1;
		char	b4:1;
		char	b5:1;
		char	b6:1;
		char	b7:1;
		char	b8:1;
		char	b9:1;
		char	b10:1;
		char	b11:1;
		char	b12:1;
		char	b13:1;
		char	b14:1;
		char	b15:1;
	} bit;
	struct{
		char	low;							/* low  8 bit */
		char	high;							/* high 8 bit */
	} byte;
	unsigned int	word;
};

			/* UART0 transmit buffer register */
#define		u0tbl		u0tb.byte.low		/* UART0 transmit buffer register Low */
#define		u0tbh		u0tb.byte.high		/* UART0 transmit buffer register High */
			/* UART1 transmit buffer register */
#define		u1tbl		u1tb.byte.low		/* UART1 transmit buffer register Low */
#define		u1tbh		u1tb.byte.high		/* UART1 transmit buffer register High */
			/* UART2 transmit buffer register */
#define		u2tbl		u2tb.byte.low		/* UART1 transmit buffer register Low */
#define		u2tbh		u2tb.byte.high		/* UART1 transmit buffer register High */
			/* A-D register  */
#define		adl			ad.byte.low		/* A-D register Low */
#define		adh			ad.byte.high		/* A-D register High */

#endif
